(defun acl-intro ()
  "check text against multi-table e.g. intro_to_acl.txt vs acl.texinfo"
  (interactive)
  (let* ((aw-dir-stub "z:\\Documents_folder\\")
	 (text-buffer (get-file-buffer (concat aw-dir-stub "texinfo\\modified_intro_to_acl.txt")))
	 (texinfo-buffer (get-file-buffer (concat aw-dir-stub "texinfo\\acl.texinfo")))
	 (aw-sep-str "->")
	 (aw-log-a t)
	 (aw-log-c t)
	 aw-m1 aw-m2 aw-m3 aw-m4 aw-m5 aw-m6 aw-m7 aw-m8 aw-m9 aw-m10 aw-text-list
	 aw-n1 aw-n2 aw-n3 aw-text-b aw-text-c aw-text-d aw-log-b aw-log-d
	 aw-line-cnt aw-text-list aw-text-list-copy aw-texinfo-buffer-window aw-text-buffer-window)
    ;; aw-sep-str could be -> also
    (set-buffer text-buffer)		; buffer is text-buffer
    (setq aw-m1 (point-marker))
    (re-search-forward "^\\s-*$")
    (setq aw-m2 (point-marker))
    (save-restriction
      (narrow-to-region aw-m1 aw-m2)
      (goto-char (point-min))
      (set-buffer texinfo-buffer)	; buffer is texinfo-buffer
      (setq aw-m3 (point-marker))
      (re-search-forward "@end multitable")
      (beginning-of-line)
      (setq aw-m4 (point-marker))
      (save-restriction
	(narrow-to-region aw-m3 aw-m4)
	(goto-char (point-min))
	(set-buffer text-buffer)	;buffer is text-buffer
	(setq aw-n2 (point-max))
	(while (and aw-log-a aw-log-c)
	  (set-buffer text-buffer)	;buffer is text-buffer
	  (setq aw-m5 (point))
	  (end-of-line)
	  (setq aw-m6 (point))
	  (forward-line)
	  (if (= (point) aw-n2)
	      (setq aw-log-a nil))
	  (setq aw-text-a (buffer-substring aw-m5 aw-m6))
	  (setq aw-n1 (string-match aw-sep-str aw-text-a))
	  (if (not aw-n1)
	      (error 'invalid-state (format (concat "text string %s did not have " aw-sep-str " in it") aw-text-a)))
	  (setq aw-text-b (aw-remove-white (substring aw-text-a 0 aw-n1) nil))
	  (setq aw-text-b (aw-quote-braces aw-text-b))
	  (setq aw-text-list nil)
	  (setq aw-text-c (substring aw-text-a (+ aw-n1 2)))
	  (setq aw-text-c (aw-remove-white aw-text-c t))
	  (setq aw-text-c (aw-quote-braces aw-text-c))
	  (setq aw-text-list (list aw-text-c))
	  (setq aw-log-b t)
	  (while (and aw-log-a aw-log-b) ;look for "continuation" lines
	    (setq aw-m9 (point))
	    (end-of-line)
	    (setq aw-m10 (point))
	    (forward-line)
	    (if (= (point) aw-n2)
		(setq aw-log-a nil))
	    (setq aw-text-d (buffer-substring aw-m9 aw-m10))
	    (setq aw-n3 (string-match aw-sep-str aw-text-d))
	    (if aw-n3
		(progn
		  (setq aw-log-b nil)
		  (goto-char aw-m9))
	      (setq aw-text-list (append aw-text-list (list (aw-remove-white aw-text-d t))))))
	  (set-buffer texinfo-buffer)	;buffer is texinfo-buffer
	  (setq aw-m7 (point))
	  (save-excursion		;look for "continuation" lines
	    (forward-line)
	    (setq aw-line-cnt 0)
	    (while (setq aw-log-d (and (not (looking-at "^@item")) (< (point) (point-max))))
	      (forward-line)
	      (setq aw-line-cnt (1+ aw-line-cnt)))
	    (setq aw-m8 (point)))
	  (setq aw-log-c (search-forward aw-text-b aw-m8 t))
	  (setq aw-text-list-copy aw-text-list)
	  (while (and aw-log-c (setq aw-text-car (car aw-text-list-copy))) ;test for match
	    (setq aw-text-car (aw-quote-braces aw-text-car))
	    (setq aw-log-c (and aw-log-c (search-forward aw-text-car aw-m8 t)))
	    (setq aw-text-list-copy (cdr aw-text-list-copy)))
	  (if (not aw-log-c)
	      (message "unable to find %s and %s in acl.texinfo file narrowed region" aw-text-b aw-text-list)
	    (goto-char aw-m8)))
	(set-buffer text-buffer)
	(setq aw-m1 (point-marker))
	(set-buffer texinfo-buffer)
	(setq aw-m2 (point-marker))))
    (set-buffer text-buffer)
    (goto-char aw-m1)
    (setq aw-text-buffer-window (get-buffer-window text-buffer))
    (setq aw-texinfo-buffer-window (get-buffer-window texinfo-buffer))
    (if (eq (selected-window) aw-text-buffer-window)
	(select-window aw-texinfo-buffer-window))
    (set-window-point aw-text-buffer-window aw-m1)
    (set-buffer texinfo-buffer)
    (goto-char aw-m2)
    (if (eq (selected-window) aw-texinfo-buffer-window)
	(select-window aw-text-buffer-window))
    (set-window-point aw-texinfo-buffer-window aw-m2)))
(defun aw-remove-white (aw-text-b left)
  "remove white-space on either side of string, unless left is true and then do just left side"
  (interactive "stest string:\nxleft side only")
  (let (aw-log-a aw-char aw-text-d aw-text-e aw-log-a)
    (setq aw-log-a t)
    (while aw-log-a
      (setq aw-char (elt aw-text-b 0))
      (setq aw-log-a (or (equal aw-char ?\ ) (equal aw-char ?\t)))
      (if aw-log-a
	  (setq aw-text-b (substring aw-text-b 1))))
    (setq aw-text-d aw-text-b)
    (if (not left)
	(progn
	  (setq aw-log-a t)
	  (while aw-log-a
	    (setq aw-char (elt aw-text-d (1- (length aw-text-d))))
	    (setq aw-log-a (or (equal aw-char ?\ ) (equal aw-char ?\t)))
	    (if aw-log-a
		(setq aw-text-d (substring aw-text-d 0 -1))))))
    (setq aw-text-e aw-text-d)))
(defun aw-quote-braces (aw-text)
  "if braces found, precede them by @"
  (interactive "stest string:")
  (let ((aw-n2 0)
	aw-n1)
    (while (setq aw-n1 (string-match "\\([{}]\\)" aw-text aw-n2))
      (setq aw-n2 (+ aw-n1 2))
      (setq aw-text (replace-match "@\\1" nil nil aw-text)))
    aw-text))
